<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        form {
            border: 1px solid #ddd;
            padding: 5px;
            width: 225px;
            background: #efefef;
        }

        label {
            display: block;
            margin-top: 5px;
        }

        input,
        textarea,
        select,
        option {
            min-width: 200px;
        }
    </style>

</head>

<body>
    <div id="app">
        <form @submit.prevent="submitForm()">
            <p v-if="errors.length">
                <b>Please correct the following errors :</b>
            <ul>
                <li v-for="error in errors">{{ error }}</li>
            </ul>
            </p>
            <label>Nama : </label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="name" ref="name" v-model="name">
            <label>Alamat : </label>
            <textarea name="address" :disabled="buttonStatus == 'upload'" ref="address" v-model="address"></textarea>
            <label>No. HP : </label>
            <input type="text" name="no_hp" :disabled="buttonStatus == 'upload'" ref="no_hp" v-model="no_hp">
            <br><br>

            <div v-if="buttonStatus == 'submit'">
                <input type="submit" value="SUBMIT">
            </div>
            <div v-else-if="buttonStatus == 'update'">
                <input type="button" @click="updateMember(idEditMember)" value="UPDATE">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top:5px">
            </div>
            <div v-else-if="buttonStatus == 'upload'">
                <input type="file" name="photo_profile" ref="photo_profile">
                <input type="button" value="UPLOAD" @click="submitPhoto(idUploadMember)" style="margin-top:5px;">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top:5px">
            </div>

        </form>

        <br><br>

        <table border=1>
            <tr v-for="member of members">
                <td>
                    <img width=100 :src="member.photo_profile ? domain + member.photo_profile : 'https://dummyimage.com/600x400/000/fff'"
                        alt="">
                </td>
                <td>
                    <b>Nama : </b> {{ member.name }} <br>
                    <b>Alamat : </b> {{ member.address }} <br>
                    <b>No. HP : </b> {{ member.no_hp }} <br>
                </td>
                <td>
                    <button @click="editMember(member)">Edit</button>
                    <button @click="removeMember(member.id)">Hapus</button>
                    <button @click="uploadPhoto(member)">Upload Foto</button>
                </td>
            </tr>
        </table>

    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                name: '',
                address: '',
                no_hp: '',
                debugger: '',
                errors: [],
                members: [],
                domain: 'http://demo-api-vue.sanbercloud.com',
                buttonStatus: 'submit',
                idEditMember: null,
                idUploadMember: null
            },
            methods: {

                validationForm: function () {
                    this.errors = []

                    if (this.name.length === 0) {
                        this.errors.push('Nama harus diisi!')
                        this.$refs.name.focus()
                    }

                    if (this.address.length === 0) {
                        this.errors.push('Alamat tidak boleh kosong!')
                        this.$refs.address.focus()
                    }

                    if (this.no_hp.length == 0) {
                        this.errors.push('No. HP harus diisi')
                        this.$refs.no_hp.focus()
                    }
                },

                submitForm: function () {
                    this.validationForm()

                    if (this.errors.length === 0) {

                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        const config = {
                            method: "post",
                            url: `${this.domain}/api/member`,
                            data: formData
                        }

                        axios(config)
                            .then((response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)

                            })
                            .catch((error) => {

                            })
                    }
                },

                getMembers: function () {

                    const config = {
                        method: "get",
                        url: `${this.domain}/api/member`
                    }

                    axios(config)
                        .then((response) => {
                            this.members = response.data.members
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },

                removeMember: function (id) {
                    const config = {
                        method: "post",
                        url: `${this.domain}/api/member/${id}`,
                        params: { _method: "DELETE" }
                    }

                    axios(config)
                        .then((response) => {
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })

                    console.log(id)
                },

                editMember: function (member) {
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'update'
                    this.idEditMember = member.id
                },

                clearForm: function () {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                    this.idUploadMember = null
                },

                updateMember: function (id) {

                    this.validationForm()

                    if (this.errors.length === 0) {

                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        let config = {
                            method: "post",
                            url: `${this.domain}/api/member/${id}`,
                            params: { _method: 'PUT' },
                            data: formData
                        }

                        axios(config)
                            .then((response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch((error) => {
                                console.log(error)
                            })
                    }


                },

                uploadPhoto: function (member) {
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'upload'
                    this.idUploadMember = member.id
                },

                submitPhoto: function (id) {

                    let file = this.$refs.photo_profile.files[0]

                    let formData = new FormData()
                    formData.append('photo_profile', file)

                    let config = {
                        method: "post",
                        url: `${this.domain}/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }

                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getMembers()
                            alert(response.data.message)

                        })
                        .catch((error) => {
                            console.log(error)
                        })
                }
            },
            created() {
                this.getMembers()
            }

        })
    </script>

</body>

</html>
